<?php

namespace Shop\Controller;

use Psr\Container\ContainerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Shop\DB\Client;
use Shop\DB\Products;


class ClientCreate
{
   protected $container;
   protected $twig;

   // constructor receives container instance
   public function __construct(ContainerInterface $container)
   {
       $this->container = $container;
   }

   public function getClientCreate(ServerRequestInterface $request, ResponseInterface $response, array $args): ResponseInterface
   {
    $db2 = new Client($this->container);
    $a = $db2->getClientName($args['client']);
    
    if ($request->getMethod() == "GET") {
        $vars = ['clients' => $a, 'args' => $args['client']];
        $container = $this->container;
        $twig = $container->get('twig'); 
        $b = $twig->render('clientcreate.html.twig',$vars);
        $response->getBody()->write($b);
        return $response;
    } else {
        $db2 = new Products();
        $ref = $request->getParsedBody()['reference'];
        $client = $args['client'];
        $db2->getProductId($client, $ref);
        return $response->withHeader('Location', '/orders/' . $args['client']);
    };
   }
	}