<?php

namespace Shop\Controller;

use Psr\Container\ContainerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Shop\DB\Client;

class Customers
{
   private $container;

   // constructor receives container instance
   public function __construct(ContainerInterface $container)
   {
       $this->container = $container;
   }

   public function getCustomers(ServerRequestInterface $request, ResponseInterface $response, array $args): ResponseInterface
   {
    $db = new Client($this->container);
    $customers = $db->getClients();

    $container = $this->container;
		$twig = $container->get('twig');
 
    $vars = ["customers" => $customers];

		$a = $twig->render('customers.html.twig', $vars);
		$response->getBody()->write($a);

    return $response;
	}
}