<?php

namespace Shop\Controller;

use Psr\Container\ContainerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Slim\Psr7\Response;
use Shop\DB\Order_lines;
use Shop\DB\Orders;
use Shop\DB\Products;

class IdCreate
{
   private $container;

   // constructor receives container instance
   public function __construct(ContainerInterface $container)
   {
       $this->container = $container;
   }

   public function getPostIdCreate(ServerRequestInterface $request, ResponseInterface $response, array $args): ResponseInterface
   {
    if ($request->getMethod() == "GET") {
        $db2 = new Orders();
        $id = $args['id'];
        $a = $db2->getReferenceOrders($id);

        $vars = ['refOrders' => $a, 'args' => $args['id']];
        $container = $this->container;
        $twig = $container->get('twig'); 
        $b = $twig->render('ordercreate.html.twig',$vars);
        $response->getBody()->write($b);

        return $response;
    } else {
        $productid = $request->getParsedBody()['id'];
        $qty = $request->getParsedBody()['qty'];
        $db2 = new Products();

        // vraag details van het product op
        $product = $db2->getDetailsproduct($productid);
        $order_id = $args['id'];
        $unitprice = $product['unitprice'];
        $vatperc = $product['vatperc'];

        // bereken de prijs van de lijn
        $subtotal = $qty * $unitprice;
        $vat = $subtotal * $vatperc / 100;
        $total = $subtotal + $vat;

        // voeg orderlijn toe
        $db3 = new Order_lines();
        $db3->getOrderLines($order_id, $productid, $qty, $subtotal, $vat, $total);

        // update het order met nieuwe totalen
        $db4 = new Orders();
        $db4->updateOrder($order_id, $subtotal, $vat, $total);

        return $response->withHeader('Location', '/order/' . $args['id'] . '/create');
    };
       
   }
	}