<?php

namespace Shop\Controller;

use Psr\Container\ContainerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Shop\DB\Orders as DB_Orders;
use Shop\DB\Client;

class Orders
{
   private $container;

   // constructor receives container instance
   public function __construct(ContainerInterface $container)
   {
       $this->container = $container;
   }

   public function getOrders(ServerRequestInterface $request, ResponseInterface $response, array $args): ResponseInterface
   {
    $db = new DB_Orders();

    if ($args['client']) {
        // orders 1 client
        $client = $args['client'];
        $res = $db->getOrderOneClient($client);
        
        // naam van de klant
       
        $db2 = new Client($this->container);
        $a = $db2->getClientName($client);
        $response->getBody()->write('<a href="/orders/' . $args['client'] . '/create">Create order</a>');
        $response->getBody()->write("<h1>ORDERS LIST FOR CLIENT " . $a['firstname'] . " " . $a['lastname'] . "</h1>");
        $response->getBody()->write('<hr/>');
        $response->getBody()->write("<table>");
    } else {
        // alle klanten
        $response->getBody()->write("<h1>ORDERS LIST FOR ALL CLIENTS </h1>");
        $response->getBody()->write('<hr/>');
        $response->getBody()->write("<table>");
        $client = $args['client'];
        $res = $db->getOrderAllClients();
    }

    // toon de orders van 1 of alle klanten
    while ($row = $res->fetchArray(SQLITE3_ASSOC)) {
        // maak hier een deftige tabel van
        $response->getBody()->write("<tr><td>" . " <a href=\"/order/" . $row['id'] . "\">" . $row["reference"] . "</a> " . $row['subtotal'] . " " . $row['vat'] . " " . $row['total'] . "</td></tr>");
    }

    $response->getBody()->write("</table>");
    $response->getBody()->write('<hr/>');

    $response->getBody()->write('<a href="/customers">Back to customer list</a> <a href="/orders">Back to order list</a>');

    return $response;
   }
	}